using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Threading;
using System.IO;
using System.Net.Sockets;

namespace spring2015winchatclient
{
    public partial class Form1 : Form
    {

        private NetworkStream clientStream;
        private BinaryReader reader;
        private BinaryWriter writer;
        private Thread clientThread;
        private string message = null;

        
        public Form1()
        {
            InitializeComponent();
        }

        public void RunClient()
        {
            TcpClient client;
            //init client
            string ipaddr;
            Int32 port;
            if (textBox2.Text != "")
                ipaddr = textBox2.Text;
            else
            {
                textBox2.Text = "127.0.0.1";
                ipaddr = textBox2.Text;
            }
            try
            {
                port = Convert.ToInt32(textBox3.Text);
            }
            catch
            {
                port = 8221;
                textBox3.Text = "8221";
            }

            IPAddress ip = IPAddress.Parse(ipaddr);
            try
            {
                client = new TcpClient();
                client.Connect(ip, port);
                //client.Connect("localhost", port);
                clientStream = client.GetStream();
                writer = new BinaryWriter(clientStream);
                reader = new BinaryReader(clientStream);
                do
                {
                    try
                    {
                        message = reader.ReadString();
                        listBox1.Items.Add(message);
                    }
                    catch (Exception error)
                    {
                        MessageBox.Show("Error reading from server " + error.ToString());
                    }

                } while (message != "QUIT");
                //closing down the connection
                writer.Close();
                reader.Close();
                clientStream.Close();
                client.Close();
                Application.Exit();
            }
            catch (Exception error)
            {
                MessageBox.Show("Error creating connection " + error.ToString());
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //connect
            clientThread = new Thread(new ThreadStart(RunClient));
            clientThread.Start();
            button1.Enabled = false;
        }
 
 
        private void Form1_Load(object sender, EventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;
        }

        private void textBox1_KeyDown_1(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                writer.Write(textBox1.Text);
                textBox1.Clear();
            }
        }

    }
}