using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO;

namespace spring2015winchatserver
{
    public partial class Form1 : Form
    {
        private Socket connection;
        private NetworkStream socketStream;
        private BinaryReader reader;
        private BinaryWriter writer;
        private Thread serverThread;
        static public Int32 port = 8221;
        static public string msg = null;

        
        public Form1()
        {
            InitializeComponent();
        }

        public void RunServer()
        {
            if (textBox2.Text != "")
                port = Convert.ToInt32(textBox2.Text);
            
            try
            {
                IPAddress localAddr = IPAddress.Parse("127.0.0.1");
                TcpListener server = new TcpListener(localAddr, port);
                server.Start();
                connection = server.AcceptSocket();
                socketStream = new NetworkStream(connection);
                writer = new BinaryWriter(socketStream);
                reader = new BinaryReader(socketStream);
                //connection made
                //tell the client
                writer.Write("From server - connection ok");
                listBox1.Items.Add("a client is connected");
                //string msg = null;
                do
                {
                    try
                    {
                        msg = reader.ReadString();
                        listBox1.Items.Add(msg);
                        writer.Write(msg);
                    }
                    catch
                    {
                        break;
                    }
                }
                while (msg != "QUIT");
                //close connection
                reader.Close();
                writer.Close();
                socketStream.Close();
                connection.Close();
                serverThread.Abort();
                Application.Exit();
            }
            catch (Exception error)
            {
                MessageBox.Show(error.ToString());
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //start listener
            serverThread = new Thread(new ThreadStart(RunServer));
            serverThread.Start();
            button1.Enabled = false;
        }


        private void button2_Click(object sender, EventArgs e)
        {
            //disconnect
            writer.Write("QUIT");
            reader.Close();
            writer.Close();
            socketStream.Close();
            connection.Close();
            serverThread.Abort();
            Application.Exit();

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
        }

        private void textBox1_KeyDown_1(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                writer.Write(textBox1.Text);
                textBox1.Clear();
            }
        }
    }
}